#ifndef CLICKABLELABEL_H
#define CLICKABLELABEL_H

#include <QLabel>

/*!
Class derived from QLabel which additionally fires the clicked-signal when mousePressEvent is detected
*/
class ClickableLabel : public QLabel
{
	Q_OBJECT

public:
	explicit ClickableLabel(QWidget * parent = 0);
	~ClickableLabel();

signals:
	/*!
	Fired when mousePressEvent is detected
	*/
	void clicked();

protected:
	/*!
	Is called when a mouse button is pressed while the cursor is inside the label
	*/
	void mousePressEvent (QMouseEvent * event);
};

#endif // CLICKABLELABEL_H
