#include "stdafx.h"
#include "graphsorter.h"

const char* const GraphSorter::sortingAttribute_str[SortingAttribute::SIZE_OF_ENUM] ={"OnsetTime asc", "OnsetTime desc", "Volatility asc", "Volatility desc"};

GraphSorter::GraphSorter(QObject *parent)
	: QObject(parent)
{

}

GraphSorter::~GraphSorter()
{

}

bool compOnsetAsc (const DataItem* a, const DataItem* b) {return a->onsetTime < b->onsetTime;}
bool compOnsetDesc (const DataItem* a, const DataItem* b) {return a->onsetTime > b->onsetTime;}
bool compVolAsc (const DataItem* a, const DataItem* b) {return a->volatility < b->volatility;}
bool compVolDesc (const DataItem* a, const DataItem* b) {return a->volatility > b->volatility;}

void GraphSorter::Sort(DataSet& data, const SortingAttribute attribute)
{
	DataPtrListRef dat = data.getSortedData();
	switch(attribute)
	{
	case SortingAttribute::OnsetTimeASC:
		std::sort(dat.begin(), dat.end(), compOnsetAsc);
		break;
	case SortingAttribute::OnsetTimeDESC:
		std::sort(dat.begin(), dat.end(), compOnsetDesc);
		break;
	case SortingAttribute::VolatilityASC:
		std::sort(dat.begin(), dat.end(), compVolAsc);
		break;
	case SortingAttribute::VolatilityDESC:
		std::sort(dat.begin(), dat.end(), compVolDesc);
		break;
	}

	this->orderLayers(data);
}
