#ifndef GRAPHVIEW_H
#define GRAPHVIEW_H

#include <QGraphicsView>
#include "graphscene.h"

/*!
A \ref QGraphicsView with special handling for \ref GraphScene scenes.
*/
class GraphView : public QGraphicsView
{
	Q_OBJECT

public:
	explicit GraphView(GraphScene* scene,QWidget *parent);
	~GraphView();

	/*!
	Resets the view to show the whole scene.
	*/
	void ResetView();
protected:
	void wheelEvent(QWheelEvent* ev) override;
	void resizeEvent(QResizeEvent* ev) override;
	void mousePressEvent(QMouseEvent* ev) override;
private:
	void updateSceneRect();
	QRectF mCurSceneRect;
	bool mUpdateRect;
private slots:
	void scrolled(int val);
};

#endif // GRAPHVIEW_H
