#ifndef INSIDEOUTGRAPHSORTER_H
#define INSIDEOUTGRAPHSORTER_H

#include <QObject>
#include "graphsorter.h"

/*!
Class describes a sorting algorithm which sorts the \ref DataSet in order to put the first elements of the sorted list near the baseline and the last to the outside
The dataitems are added to the top and bottom alternating
*/
class InsideOutGraphSorter : public GraphSorter
{
	Q_OBJECT
	Q_INTERFACES(INamedObject)

public:
	InsideOutGraphSorter(QObject *parent);
	~InsideOutGraphSorter();

	/*!
	Gets the name of the algorithm to display in the GUI
	*/
	QString GetName() { return "InsideOut"; }

private:
	void orderLayers(DataSet& data);	
};

#endif // INSIDEOUTGRAPHSORTER_H
