#ifndef MAINFORM_H
#define MAINFORM_H

#include <QtWidgets/QMainWindow>
#include "ui_mainform.h"

/*!
The main window of the application. Composes the GUI, handles parameter changes, etc.
*/
class MainForm : public QMainWindow
{
	Q_OBJECT

public:
	MainForm(QWidget *parent = 0);
	~MainForm();

private slots:
	void on_btnLoad_clicked();
	void on_btnRandom_clicked();
	void on_begincolorLabel_clicked();
	void on_endcolorLabel_clicked();
	void on_baseLineComboBox_currentIndexChanged(int i);
	void on_sortingComboBox_currentIndexChanged(int i);
	void on_interpolationComboBox_currentIndexChanged(int i);
	void on_sortattributeComboBox_currentIndexChanged(int i);
	void on_coloringComboBox_currentIndexChanged(int i);
	void on_labelCheckBox_clicked(bool val);
	void on_twodcoloringCheckBox_clicked(bool val);

	void on_exportButton_clicked();

	void redrawRequest();

private:
	class MainFormPrivate& d;

	bool loadFile(const QString& path, bool infoPopup = true);
	QString getGradientStyleSheet(QVariant const color1, QVariant const color2) const;
	QString getColorStyleSheet(QVariant const color) const;
	void updateColorGradient(QColor const color1, QColor const color2);
};

#endif // MAINFORM_H
