#include "stdafx.h"
#include "minwigglegraphlayouter.h"

MinWiggleGraphLayouter::MinWiggleGraphLayouter(QObject *parent)
	: GraphLayouter(parent)
{

}

MinWiggleGraphLayouter::~MinWiggleGraphLayouter()
{

}

void MinWiggleGraphLayouter::calculateBaseLine(DataSet& dataset, QVector<double>& baseline)
{
	baseline.fill(0.0,dataset.getSizeX());

	int layer = 0;

	const DataPtrListRef dat = dataset.getSortedData();
	for (auto it = dat.begin(); it != dat.end(); it++)
	{
		DataItem& item = **it;
		EntryVector& timeSeries = item.data;

		for (int i = 0; i < timeSeries.size(); i++) 
		{
			baseline[i] += -((dataset.getSizeY()-layer+1.0)*timeSeries.at(i))/(dataset.getSizeY()+1.0);
		}
		layer++;
	}
}
