#ifndef MINWIGGLEGRAPHLAYOUTER_H
#define MINWIGGLEGRAPHLAYOUTER_H

#include "graphlayouter.h"

/*!
Class describes a layouting algorithm which minimizes the sum of squares of the layer slopes at each data value
*/
class MinWiggleGraphLayouter : public GraphLayouter
{
	Q_OBJECT
	Q_INTERFACES(INamedObject)

public:
	MinWiggleGraphLayouter(QObject *parent);
	~MinWiggleGraphLayouter();

	/*!
	Gets the name of the algorithm to display in the GUI
	*/
	QString GetName() { return "MinWiggle"; }

private:
	void calculateBaseLine(DataSet& dataset, QVector<double>& baseline);

};

#endif // MINWIGGLEGRAPHLAYOUTER_H
