#ifndef NAMEDOBJECT_H
#define NAMEDOBJECT_H

#include <QObject>

/*!
	Interface for objects which have a name
*/
class INamedObject
{
public:
	virtual ~INamedObject() {}
	/*!
	Returns a user-presentable name for the object.
	*/
	virtual QString GetName() = 0;
};

Q_DECLARE_INTERFACE(INamedObject, "StackedGraphs.INamedObject")

#endif // NAMEDOBJECT_H
