#include "stdafx.h"
#include "streamgraphlayouter.h"

StreamGraphLayouter::StreamGraphLayouter(QObject *parent)
	: GraphLayouter(parent)
{

}

StreamGraphLayouter::~StreamGraphLayouter()
{

}

void StreamGraphLayouter::calculateBaseLine(DataSet& dataset, QVector<double>& baseline)
{
	baseline.fill(0.0,dataset.getSizeX());

	QVector<double> cumHeight;
	cumHeight.fill(0.0,dataset.getSizeX());

	const DataPtrListRef dat = dataset.getSortedData();
	for ( auto it = dat.begin(); it != dat.end(); it++)
	{
		DataItem& item = **it;
		EntryVector& timeSeries = item.data;

		for (int i = 0; i < timeSeries.size(); i++) 
		{
			cumHeight[i] += timeSeries.at(i);
		}
	}

	QVector<double> derived;
	derived.fill(0.0,dataset.getSizeX());

	for (auto it = dat.begin(); it != dat.end(); it++)
	{
		DataItem& item = **it;
		EntryVector& timeSeries = item.data;

		for (int i = 0; i < timeSeries.size(); i++) 
		{
			double df = 0.0;

			if(i>0){
				df = timeSeries.at(i)-timeSeries.at(i-1);
			}

			int j=0;
			double sum=0.0;
			for (auto it2 = dat.begin(); it2 != it; it2++)
			{
				DataItem& item2 = **it2;
				if(i>0){
					sum += item2.data.at(i)-item2.data.at(i-1);
				}
			}
			derived[i] += -timeSeries.at(i)/cumHeight.at(i)*(0.5*df + sum);
		}
	}

	double g = 0.0;
	for(int i=0;i<baseline.size();i++){
		g += derived[i];

		baseline[i] = g;
	}
}
