#include "stdafx.h"
#include "themerivergraphlayouter.h"

ThemeRiverGraphLayouter::ThemeRiverGraphLayouter(QObject *parent)
	: GraphLayouter(parent)
{

}

ThemeRiverGraphLayouter::~ThemeRiverGraphLayouter()
{

}

void ThemeRiverGraphLayouter::calculateBaseLine(DataSet& dataset, QVector<double>& baseline)
{
	baseline.fill(0.0,dataset.getSizeX());

	//centering at y-axis	
	const DataPtrListRef dat = dataset.getSortedData();
	for (auto it = dat.begin(); it != dat.end(); it++)
	{
		DataItem& item = **it;
		EntryVector& timeSeries = item.data;

		for (int i = 0; i < timeSeries.size(); i++) 
		{
			baseline[i] += -timeSeries.at(i)/2.0;
		}
	}
}
