#include "stdafx.h"
#include "weightedgraphsorter.h"

WeightedGraphSorter::WeightedGraphSorter(QObject *parent)
	: GraphSorter(parent)
{

}

WeightedGraphSorter::~WeightedGraphSorter()
{

}

void WeightedGraphSorter::orderLayers(DataSet& data)
{
	int topSum = 0;
	int bottomSum = 0;
	QList<DataItem*> topList;
	QList<DataItem*> bottomList;

	//each dataitem (index) comes either into the bottom or top container
    for (int i=0; i<data.getSizeY(); i++) {
      if (bottomSum < topSum) {
        bottomList.append(data.getSortedData().at(i));
        bottomSum += data.getSortedData().at(i)->sum;
      } else {
		topList.append(data.getSortedData().at(i));
		topSum += data.getSortedData().at(i)->sum;
      }
    }

	//clear the datalist and insert the items at there corrected position
	data.getSortedData().clear();
	for (int i = 0; i < bottomList.size(); i++) {
		data.getSortedData().prepend(bottomList[i]);
	}
	for (int i = 0; i < topList.size(); i++) {
		data.getSortedData().append(topList[i]);
	}
}
