#ifndef WEIGHTEDGRAPHSORTER_H
#define WEIGHTEDGRAPHSORTER_H

#include <QObject>
#include "graphsorter.h"

/*!
Class describes a sorting algorithm which sorts the \ref DataSet in order to put the first elements of the sorted list near the baseline and the last to the outside
The dataitems are added to the top if the sum of all items at the top is less than the sum of all items at the bottom or at the bottom otherwise
*/
class WeightedGraphSorter : public GraphSorter
{
	Q_OBJECT
	Q_INTERFACES(INamedObject)

public:
	WeightedGraphSorter(QObject *parent);
	~WeightedGraphSorter();

	QString GetName() { return "Weighted"; }

private:
	void orderLayers(DataSet& data);
};

#endif // WEIGHTEDGRAPHSORTER_H
